program DropHref;

{$APPTYPE CONSOLE}

{$R 'version.res' 'version.rc'}

uses
    Classes,
    SysUtils,
    IniFiles,
    ClipBrd,
    GDIPOBJ in 'GDIPOBJ.pas';

//-----------------------------------------------------------------------------
//  t@CTCY擾(FileSize)
function FileSizeByFileSize(const FileName: string): Int64;
var
    F: file;                            //  ^Ȃt@C
begin
    Result := -1;
    try
        AssignFile(F, FileName);
        try
            Reset(F, 1);                //  oCgt@C
            Result := FileSize(F);
        finally
            CloseFile(F);
        end;
    except
    end;
end;

//-----------------------------------------------------------------------------
const
    TAG_NAME   = '#NAME#';      //  t@C
    TAG_SIZE   = '#SIZE#';      //  t@C̃TCY(byte)
    TAG_WIDTH  = '#WIDTH#';     //  摜̕
    TAG_HEIGHT = '#HEIGHT#';    //  摜̍
    TAG_DIR1   = '#DIR1#';      //  ЂƂ̃tH_
    TAG_DIR2   = '#DIR2#';      //  ӂ̃tH_
    TAG_CRLF   = '#CRLF#';      //  s

//-----------------------------------------------------------------------------
var
    LIni: TIniFile;
    LHrefExts: String;
    LHrefTmp: String;
    LImgExts: String;
    LImgTmp: String;
var
    i: Integer;
    LFileName: String;
    LImage: TGPImage;
    LExt: String;
    LName: String;
    LSize: Cardinal;
    LSizeText: String;
    LDir1: String;
    LDir2: String;
    LWidth: Integer;
    LHeight: Integer;
    LTemp: String;
var
    LBuf: TStringList;
begin
    //  ݒǂݍ
    LHrefExts := '.zip;.lzh;';
    LHrefTmp  := '<p><a target="download" href="#DIR1#/#NAME#">#NAME#(#SIZE#bytes)</a>';
    LImgExts  := '.png;.jpg;.gif;';
    LImgTmp   := '<p>#CRLF#<br><img src="#DIR1#/#NAME#" width=#WIDTH# height=#HEIGHT#>';
    LIni := nil;
    try
        try
            LIni := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
            LHrefExts := LowerCase(LIni.ReadString('href', 'Extention', LHrefExts));
            LHrefTmp  := LIni.ReadString('href', 'Template', LHrefTmp);
            LImgExts  := LowerCase(LIni.ReadString('img', 'Extention', LImgExts));
            LImgTmp   := LIni.ReadString('img', 'Template', LImgTmp);
            LIni.WriteString('href', 'Extention', LHrefExts);
            LIni.WriteString('href', 'Template', LHrefTmp);
            LIni.WriteString('img', 'Extention', LImgExts);
            LIni.WriteString('img', 'Template', LImgTmp);

            LIni.WriteString('help', '@\', 'hbvt@C̏ɂăNbv{[hɃRs[');
            LIni.WriteString('tag_help', '#NAME#', 't@C');
            LIni.WriteString('tag_help', '#SIZE#', 't@C̃TCY(byte)');
            LIni.WriteString('tag_help', '#WIDTH#', '摜̕');
            LIni.WriteString('tag_help', '#HEIGHT#', '摜̍');
            LIni.WriteString('tag_help', '#DIR1#', 'ЂƂ̃tH_');
            LIni.WriteString('tag_help', '#DIR2#', 'ӂ̃tH_');
            LIni.WriteString('tag_help', '#CRLF#', 's');
        finally
            LIni.Free();
        end;
    except
        //
    end;

    LBuf := nil;
    try
        LBuf := TStringList.Create();

        //  hbvꂽt@C
        for i := 1 to ParamCount do
        begin
            //  t@Co
            LFileName := ParamStr(i);
            //  t@ĈݑΏۂɂ
            if (FileExists(LFileName)) then
            begin
                //  t@C
                LName := ExtractFileName(LFileName);
                //  ЂƂ̃tH_
                LTemp := ExtractFileDir(LFileName);
                LDir1 := ExtractFileName(LTemp);
                //  ӂ̃tH_
                LTemp := ExtractFileDir(LTemp);
                LDir2 := ExtractFileName(LTemp);
                //  TCY
                LSize := FileSizeByFileSize(LFileName);
                LSizeText := FormatFloat('#,##0', LSize);
                //  
                LWidth := 0;
                //  
                LHeight := 0;

                //  gq
                LExt := ExtractFileExt(LFileName);
                //  HREF
                if (Pos(LowerCase(LExt), LHrefExts) > 0) then
                begin
                    //  
                    LTemp := LHrefTmp;
                end
                else
                //  IMG
                if (Pos(LowerCase(LExt), LImgExts) > 0) then
                begin
                    //  
                    LTemp := LImgTmp;

                    //  摜낤
                    LImage := nil;
                    try
                        try
                            LImage := TGPImage.Create(LFileName);
                            LWidth := LImage.GetWidth();
                            LHeight := LImage.GetHeight();
                        finally
                            LImage.Free();
                        end;
                    except
                        //
                    end;
                end
                else
                begin
                    Continue;
                end;
                //  ^Ou
                LTemp := StringReplace(LTemp, TAG_NAME, LName, [rfReplaceAll, rfIgnoreCase]);
                LTemp := StringReplace(LTemp, TAG_SIZE, LSizeText, [rfReplaceAll, rfIgnoreCase]);
                LTemp := StringReplace(LTemp, TAG_DIR1, LDir1, [rfReplaceAll, rfIgnoreCase]);
                LTemp := StringReplace(LTemp, TAG_DIR2, LDir2, [rfReplaceAll, rfIgnoreCase]);
                LTemp := StringReplace(LTemp, TAG_WIDTH, IntToStr(LWidth), [rfReplaceAll, rfIgnoreCase]);
                LTemp := StringReplace(LTemp, TAG_HEIGHT, IntToStr(LHeight), [rfReplaceAll, rfIgnoreCase]);
                LTemp := StringReplace(LTemp, TAG_CRLF, #13#10, [rfReplaceAll, rfIgnoreCase]);
                //  Xgɒǉ
                LBuf.Add(LTemp);
            end;
        end;
        //  Nbv{[hɏ
        if (LBuf.Count > 0) then
        begin
            Clipboard.AsText := LBuf.Text; 
        end;
    finally
        LBuf.Free();
    end;
end.
